
class ConsoleScope {

inherit iwidgets::Scrolledcanvas

variable NameSpace 
variable canvas
variable counter 0

constructor {args} {
	eval itk_initialize $args  -vscrollmode dynamic -hscrollmode dynamic\
        -autoresize yes -height 300 -width 300
	set canvas [$this component canvas]
	$canvas configure  -bg white
} 

public method AssocNameSpace {pNameSpace}
public method Load {}

}

body ConsoleScope::AssocNameSpace {pNameSpace} {

set NameSpace $pNameSpace

}

body ConsoleScope::Load {} {

[$NameSpace GetRoot] refresh

}


class ConsoleResult {

inherit itk::Widget

variable NameSpace 
variable canvas
variable counter 0
variable items ""
variable cookies
variable icomponentdata


constructor {args} {

}  {

itk_component add canvas {iwidgets::scrolledcanvas $itk_interior.cv -vscrollmode dynamic -hscrollmode dynamic -autoresize yes -background white}
set canvas [$this component canvas]
# $canvas configure -bg white

itk_component add frame {iwidgets::scrolledframe $itk_interior.fb -vscrollmode dynamic -hscrollmode dynamic}
CreateControlStuff $itk_component(frame)
eval itk_initialize $args
}


public method AssocNameSpace {pNameSpace}
public method Load {hScopeItem}
public method Add {pScopeDataItem}
public method Refresh {}
public method LoadFrame {} 
public method clear {} {	$itk_component(listbox) delete 0 end }


}

body ConsoleResult::LoadFrame {} {
	catch [pack forget $itk_component(canvas)]
      catch [pack $itk_component(frame) -fill both -expand true]
      return $itk_component(frame)
}


body ConsoleResult::AssocNameSpace {pNameSpace} {

set NameSpace $pNameSpace

}


body ConsoleResult::Add {pScopeDataItem} {

	upvar $pScopeDataItem ScopeDataItem
	set hResultItem $this-[incr counter]

	set parentNode $ScopeDataItem(parent)

	set cookie($hResultItem) $ScopeDataItem(pSnapInItem)
	set icomponentdata($hResultItem) $ScopeDataItem(pIComponentData)

	# Aqui asignar icono o lo que sea que venga de esa estructura
	# O hacerlo con llamadas a IComponentData

	set ScopeItemInfo(cookie) $cookie($hResultItem)

	$icomponentdata($hResultItem) GetDisplayInfo ScopeItemInfo

	VisNode $hResultItem $canvas -icon2 $ScopeItemInfo(ResultPaneIcon)  \
	-icon $ScopeItemInfo(ResultPaneIcon) \
	-icon1 $ScopeItemInfo(ResultPaneIcon) -title "$ScopeItemInfo(ResultPaneTitle)"	
	
	lappend items $hResultItem

	return $hResultItem

}

body ConsoleResult::Load {phscopeitem} {

# This is the default si no se ha ordenado nada mas. Se cogen
# los del scope pane y se pintan en el result pane
catch [pack forget $itk_component(frame)]
catch [pack $itk_component(canvas) -fill both -expand true]

foreach item $items { delete object $item }

set items ""

set ScopeDataItem(parent) $phscopeitem

foreach son [$phscopeitem contents] {

	set info [$NameSpace GetNameSpaceInfo $son]
	set ScopeDataItem(pSnapInItem) [lindex $info 0]
	set ScopeDataItem(pIComponentData) [lindex $info 1]

	$this Add ScopeDataItem

}


$this Refresh

}

body ConsoleResult::Refresh {} {

  set oldcursor [$canvas cget -cursor]
  $canvas configure -cursor watch
  update
  $canvas delete all
  set ul(x) 5
  set ul(y) 5
  array set mid ""
  foreach item $items {
  $item resdraw ul mid
  }

  set bbox [$canvas bbox all]

  $canvas configure -cursor $oldcursor -scrollregion $bbox


}
