class VisNode {

  inherit VisualRep Node

  public variable state "closed"
  public variable virgin 1
  public variable selectcommand ""

  constructor {cwin args} {
    VisualRep::constructor $cwin

  } {
        
    eval configure $args 
  }     

  public method select {}
  public method toggle {}
    
  public method draw {ulVar midVar}
  public method resdraw {ulVar midVar}

  public method refresh {}
	    

}

body VisNode::select {} {

  VisualRep::clear $canvas
  VisualRep::select
    regsub -all {%o} $selectcommand $this cmd
  uplevel #0 $cmd

}

body VisNode::toggle {} {
  if {$state == "open"} {
  set state "closed"
  set icon $icon1
  } else {
  set state "open"
  set icon $icon2
  }
  refresh
}
	
	
body VisNode::draw {ulVar midVar} {
  upvar $ulVar ul
  upvar $midVar mid
	
  VisualRep::draw ul mid
  $canvas bind $this <ButtonPress-1> "[$this get_data NameSpace] Notify SELECT $this"
  #$canvas bind $this <KeyPress> "ss;[$this get_data NameSpace] Notify DELETE $this"
  $canvas bind $this <ButtonPress-3> "[$this get_data NameSpace] Notify RIGHT-CLICK $this"
  $canvas bind $this <Double-ButtonPress-1> "[$this get_data NameSpace] Notify TOGGLE $this"
		    
  set lr(x) [expr $ul(x) + 2*($mid(x)-$ul(x))]
  set lr(y) $ul(y)

  if {$state == "open"} {
  	
	foreach obj [contents] {
  		
		$obj draw lr mid2
  		set id [$canvas create line \
             $mid(x) $mid(y) $mid(x)  $mid2(y) $mid2(x) $mid2(y) -fill black ]
										#grey
		$canvas lower $id
  
  		if {[$obj contents] != "" }  {
	
			if {[string compare [$obj cget -state] closed]} { 
  				set id [$canvas create oval \
  	    	       	[expr $mid(x) - 3 ] [expr $mid2(y) -3] [expr $mid(x) + 3 ] [expr $mid2(y) +3]  \
				-outline black -fill white]
				#grey
			  	$canvas bind $id <ButtonPress-1> "[$this get_data NameSpace] Notify TOGGLE $obj"

				} else {
			  	set id [$canvas create oval \
      		       	[expr $mid(x) - 3 ] [expr $mid2(y) -3] [expr $mid(x) + 3 ] [expr $mid2(y) +3]  \
				-outline black -fill yellow]
							#grey
			  	$canvas bind $id <ButtonPress-1> "[$this get_data NameSpace] Notify TOGGLE $obj"
				}
			
		} else {
	
		if [$obj cget -virgin] {
				set id [$canvas create oval \
      				[expr $mid(x) - 3 ] [expr $mid2(y) -3] [expr $mid(x) + 3 ] [expr $mid2(y) +3]  \
				-outline black -fill yellow]
						#grey
				$canvas bind $id <ButtonPress-1> "[$this get_data NameSpace] Notify TOGGLE $obj"
		}
		}
   }
} 

	


       set ul(y) $lr(y)
}
       
body VisNode::refresh {} {
 
  set root $this
  while {[$root ascendant] != ""} {
  set root [$root ascendant]
  }
			   
  set oldcursor [$canvas cget -cursor]
  $canvas configure -cursor watch
  update
  $canvas delete all
  set ul(x) 5
  set ul(y) 5
  $root draw ul mid
  set bbox [$canvas bbox all]
  $canvas configure -cursor $oldcursor -scrollregion $bbox
  }

configbody VisNode::state {
if {$state != "open" && $state != "closed"} {
   error "bad value \"$state\": should be open or closed"
   }
   refresh
}

body VisNode::resdraw {ulVar midVar} {

# draw the node in rsult pane
  
  upvar $ulVar ul
  upvar $midVar mid
	
  VisualRep::draw ul mid
  $canvas bind $this <ButtonPress-1> "$this select"
  $canvas bind $this <Double-ButtonPress-1> "[$this get_data NameSpace] Notify TOGGLE $this"
		    
  #set ul(y) [expr $ul(y) + 2 * $mid(x)]

}
