
class VisualRep {
    public variable icon1 "dirclosed"
    public variable icon2 "diropen"
    public variable icon  "dirclosed"
    public variable title ""
    public variable sel 0

    protected variable canvas ""

    constructor {cwin args} {
        set canvas $cwin
        if {![info exists selectedObjs($canvas)]} {
            set selectedObjs($canvas) ""
        }
        eval configure $args
    }
    destructor {
	  deselect
        $canvas delete $this
    }

    public method draw {ulVar midVar}

    public method select {}
    public method deselect {}

    public method canvas {args}

    public method selquery {}

    private common selectedObjs
    public proc clear {canv}
    public proc selected {canv}
}



body VisualRep::draw {ulVar midVar} {
    upvar $ulVar ul
    upvar $midVar mid

    $canvas create image $ul(x) $ul(y) -image $icon \
        -anchor nw -tags [list $this $this-icon]

    set mid(x) [expr $ul(x)+[image width $icon]/2]
    set mid(y) [expr $ul(y)+[image height $icon]/2]
    set x1 [expr $ul(x)+[image width $icon]+2]
    set y1 [expr $ul(y)+[image height $icon]+2]

    if {[lsearch $selectedObjs($canvas) $this] >= 0} {
        set fill DarkBlue
        set color white
    } else {
        set fill ""
        set color black
    }

    #$canvas create rectangle $x1 $ul(y)  $y1 \
     #   -outline "" -fill $fill -tags [list $this hilite $this-hilite]
	$canvas create text $x1 $mid(y) -text $title -fill $color\
        -anchor w -tags [list $this $this-text]
    set kk [$canvas bbox $this-text]
    $canvas create rectangle [lindex $kk 0] [lindex $kk 1] [lindex $kk 2] [lindex $kk 3] \
        -outline "" -fill "$fill" -tags [list $this hilite $this-hilite]
    $canvas raise $this-text

    set ul(y) $y1
}

body VisualRep::select {} {
    $canvas itemconfigure $this-hilite -fill DarkBlue
    $canvas itemconfigure $this-text -fill White
    set sel 1
    if {[lsearch $selectedObjs($canvas) $this] < 0} {
        lappend selectedObjs($canvas) $this
    }
}

body VisualRep::deselect {} {
    $canvas itemconfigure $this-hilite -fill ""
    $canvas itemconfigure $this-text -fill black
    set sel 0
    set i [lsearch $selectedObjs($canvas) $this]
    if {$i >= 0} {
        set selectedObjs($canvas) [lreplace $selectedObjs($canvas) $i $i]
    }
}

body VisualRep::canvas {args} {
    if {[llength $args] == 0} {
        return $canvas
    }
    regsub -all {%o} $args $this args
    eval $canvas $args
}

body VisualRep::clear {canv} {
    if {[info exists selectedObjs($canv)]} {
        foreach obj $selectedObjs($canv) {
            $obj deselect
        }
    }
}

body VisualRep::selected {canv} {
    if {[info exists selectedObjs($canv)]} {
        return $selectedObjs($canv)
    }
    return ""
}

