class control_list  {

inherit itk::Widget Bean Node

public variable control_info_node
public variable directive
public variable directive_info_tree
public variable confnode
protected variable conf

constructor {args} { Widget::constructor} {

array set conf ""

itk_component add legend {message $itk_interior.legend -width 200  -text "" -justify left} {usual}
pack $itk_component(legend)  -pady 8 -fill x -expand yes -anchor n


itk_component add listbox {iwidgets::scrolledlistbox $itk_interior.listbox \
                           -vscrollmode dynamic -hscrollmode dynamic -selectmode single  -relief sunken -borderwidth 4  -exportselection 0 } {usual}
$itk_component(listbox) configure -dblclickcommand "EditElement $itk_component(listbox)"

itk_component add buttonbox {iwidgets::Buttonbox $itk_interior.bb -orient horizontal}


$itk_component(buttonbox) add Add -text Add... -command "AddElement $itk_component(listbox)" 
$itk_component(buttonbox) add Delete -text Delete -command "DeleteElement $itk_component(listbox)"
$itk_component(buttonbox) add Edit -text Edit... -command "EditElement $itk_component(listbox)"

pack  $itk_component(buttonbox) -fill both -expand yes -side bottom  -anchor n
pack $itk_component(listbox) -fill both -expand true -pady 4 -side top -anchor n

eval itk_initialize $args


}


public method initialize {}
public method load {}
public method save {} 

}

body control_list::initialize {} {

array set conf [$control_info_node get_data]
set directive [$directive_info_tree ext_contents directive $conf(directive)]

$itk_component(legend) configure -text $conf(label_text)

}

body control_list::load {} {

set tmp [$confnode ext_contents type [$directive get_data name]]

$itk_component(listbox) delete 0  end 

if {$tmp != ""} {

	foreach element [lrange [$tmp get_data dir_value] 1 end ] {
	$itk_component(listbox) insert end $element	
	}

} 


}

body control_list::save {} {

set type [$directive get_data name]
set tmp [$confnode ext_contents type $type]

set dato [[$this component listbox] get 0 end]

if { $tmp != "" } {

if { $dato != ""} {
$tmp set_data dir_value  [concat $type $dato]

} else { catch [$confnode remove $tmp] }

} else {

if { $dato != ""} {
set mynode [ConfNodeAp $this-#auto ]
$mynode set_data dir_class directive
$mynode set_data type $type
$mynode set_data dir_value  [concat $type $dato]
$mynode configure -title $dato
$confnode add $mynode
}

}

return $dato

}


