# Snap in defines the base class from where all the plug-in or modules are derived
#
# Talk a bit about Snap-in, IComponentData, etc
#



class SnapIn {

variable IComponentData
variable IComponent


}

class ApacheSnapIn {

inherit SnapIn

constructor {} {

set IComponentData [ApacheICD $this-icd -snapin $this]
set IComponent [ApacheIC  $this-ic]
array set snapinitems ""
array set hscopeitems ""


}


public method Initialize {ConsoleNameSpace} {

}


}

body ApacheSnapIn::Initialize {ConsoleNameSpace} {

$IComponentData Initialize $ConsoleNameSpace
}


#
# Apache IComponentData element
#
# Methods: comment on the methods. Simplify them and make them multipurpose. 
# Example: AddNewNode instead of AddNewVirtualHost, etc
#
#

class ApacheICD {

	inherit IComponentData
	
	variable snapinitems
	variable hscopeitems
	variable NameSpace

	public method AddVhosts {cnfnode}
	public method AddManagement {}

	public method AddLocations {cnfnode SnapInItems}
	public method AddDirectories {cnfnode SnapInItems}

	public method AddNewVirtualHost {cnfnode}
	public method AddNewDirectory {cnfnode SnapInItem}
	public method AddNewLocation {cnfnode SnapInItem}


	public method Notify {message cookie}
	public method Initialize {ConsoleNameSpace}

	public method DeleteContainer {SnapInItem}


	}

body ApacheICD::AddManagement {} {

		set snp [ApacheItem $this-mngmt]
		array set ScopeItemInfo "ScopePaneIconOpen [g_cfg get_data management]  \
		ScopePaneIconClosed [g_cfg get_data management] ScopePaneTitle {Server Management} \
		ResultPaneIcon [g_cfg get_data management] ResultPaneTitle {Server Management}"

		$snp SetDisplayInfo ScopeItemInfo
	
		array set NodeInfo {NodeType management}
		array set NodeInfo "CnfNode {}"

		$snp SetNodeInfo NodeInfo

		$this-root add $snp

		set ScopeDataItem(parent) $hscopeitems($this-root)
		set ScopeDataItem(pIComponentData) $this
		set ScopeDataItem(pSnapInItem) $snp
		set ScopeDataItem(NodeType) mangement
		set hscopeitems($snp) [$NameSpace AddItem ScopeDataItem]

		}


body ApacheICD::AddVhosts {cnfnode} {

	foreach item [$cnfnode ext_contents type virtualhost] {

	AddNewVirtualHost $item

		}
}



body ApacheICD::AddNewVirtualHost {item} {


		set snp [ApacheItem $this-#auto]
		array set ScopeItemInfo "ScopePaneIconOpen [g_cfg get_data virtualhost.icon2]  \
		ScopePaneIconClosed [g_cfg get_data virtualhost.icon1] \
		ResultPaneIcon [g_cfg get_data virtualhost.icon2] "

		set ScopeItemInfo(ScopePaneTitle)  [$item cget -title]
		set ScopeItemInfo(ResultPaneTitle) [$item cget -title]

		$snp SetDisplayInfo ScopeItemInfo
	
		array set NodeInfo {NodeType virtualhost}
		array set NodeInfo "CnfNode $item"

		$snp SetNodeInfo NodeInfo

		$this-root add $snp

		set ScopeDataItem(parent) $hscopeitems($this-root)
		set ScopeDataItem(pIComponentData) $this
		set ScopeDataItem(pSnapInItem) $snp
		set ScopeDataItem(NodeType) virtualhost
		set hscopeitems($snp) [$NameSpace AddItem ScopeDataItem]

}


body ApacheICD::AddLocations {cnfnode SnapInItem} {

	foreach item [$cnfnode ext_contents type location] {
		AddNewLocation $item $SnapInItem

		}
}


body ApacheICD::AddDirectories {cnfnode SnapInItem} {

	foreach item [$cnfnode ext_contents type directory] {
		AddNewDirectory $item $SnapInItem
		}
}


body ApacheICD::AddNewDirectory {item SnapInItem} {


		set snp [ApacheItem $this-#auto]
		array set ScopeItemInfo "ScopePaneIconOpen [g_cfg get_data directory.icon1]  \
		ScopePaneIconClosed [g_cfg get_data directory.icon1]  \
		ResultPaneIcon [g_cfg get_data directory.icon1] "

		set ScopeItemInfo(ScopePaneTitle)  [$item cget -title]
		set ScopeItemInfo(ResultPaneTitle) [$item cget -title]

		$snp SetDisplayInfo ScopeItemInfo
	
		array set NodeInfo {NodeType directory}
		array set NodeInfo "CnfNode $item"
		$snp SetNodeInfo NodeInfo

		$SnapInItem add $snp

		set ScopeDataItem(parent) $hscopeitems($SnapInItem)
		set ScopeDataItem(pIComponentData) $this
		set ScopeDataItem(pSnapInItem) $snp
		set ScopeDataItem(NodeType) directory
		set hscopeitems($snp) [$NameSpace AddItem ScopeDataItem]
		$hscopeitems($snp) configure -virgin 0
		
}



body ApacheICD::AddNewLocation {item SnapInItem} {


		set snp [ApacheItem $this-#auto]
		array set ScopeItemInfo "ScopePaneIconOpen [g_cfg get_data location.icon2]  \
		ScopePaneIconClosed [g_cfg get_data location.icon2] ScopePaneTitle \{[$item cget -title]\} \
		ResultPaneIcon [g_cfg get_data location.icon2] ResultPaneTitle \{[$item cget -title]\}"

		$snp SetDisplayInfo ScopeItemInfo
	
		array set NodeInfo {NodeType location}
		array set NodeInfo "CnfNode $item"
		$snp SetNodeInfo NodeInfo

		$SnapInItem add $snp

		set ScopeDataItem(parent) $hscopeitems($SnapInItem)
		set ScopeDataItem(pIComponentData) $this
		set ScopeDataItem(pSnapInItem) $snp
		set ScopeDataItem(NodeType) location
		set hscopeitems($snp) [$NameSpace AddItem ScopeDataItem]
		$hscopeitems($snp) configure -virgin 0

}




body ApacheICD::Notify {message SnapInItem} {

	array set NodeInfo ""
	
	$SnapInItem GetNodeInfo NodeInfo
	
	switch $NodeInfo(NodeType)  MainNode {

		switch $message EXPAND {
			
		#Creamos un nodo llamado Main Server y ahi metemos la configuracion principal
		AddManagement
		
		set snp [ApacheItem $this-mainserver]
		array set ScopeItemInfo "ScopePaneIconOpen [g_cfg get_data virtualhost.icon2]  \
		ScopePaneIconClosed [g_cfg get_data virtualhost.icon1] ScopePaneTitle {Default WebSite} \
		ResultPaneIcon [g_cfg get_data virtualhost.icon2] ResultPaneTitle {Default WebSite}"

		$snp SetDisplayInfo ScopeItemInfo
	
		array set NodeInfo {NodeType mainserver}
		array set NodeInfo "CnfNode $NodeInfo(CnfNode)"
		$snp SetNodeInfo NodeInfo

		$SnapInItem add $snp

		set ScopeDataItem(parent) $hscopeitems($SnapInItem)
		set ScopeDataItem(pIComponentData) $this
		set ScopeDataItem(pSnapInItem) $snp
		set ScopeDataItem(NodeType) mainserver
		set hscopeitems($snp) [$NameSpace AddItem ScopeDataItem]

		AddVhosts $NodeInfo(CnfNode)

		} 

	} mainserver {

		switch $message EXPAND {
		AddLocations $NodeInfo(CnfNode)  $SnapInItem
		AddDirectories $NodeInfo(CnfNode)  $SnapInItem 
		}

	} virtualhost {
		
		switch $message EXPAND {
	
			AddLocations $NodeInfo(CnfNode) $SnapInItem
			AddDirectories $NodeInfo(CnfNode)  $SnapInItem
	
		} DELETE {
	
			DeleteContainer  $SnapInItem
			$NameSpace Refresh
	
		} 

	} directory {

	switch $message DELETE {
	
			DeleteContainer  $SnapInItem
			$NameSpace Refresh

		} 


	}  location {

	switch $message DELETE {
	
			DeleteContainer  $SnapInItem
			$NameSpace Refresh
	
		} 


	} limit {

	switch $message DELETE {
	
			DeleteContainer  $SnapInItem
			$NameSpace Refresh
	
		} 


	}


	 
			
}	


body ApacheICD::DeleteContainer {SnapInItem} {


	foreach son [$SnapInItem contents] {
	DeleteContainer $son
	}

	array set NodeInfo ""
	$SnapInItem GetNodeInfo NodeInfo
	$NameSpace DeleteItem  $hscopeitems($SnapInItem)
	#delete object $hscopeitems($SnapInItem)
      [$NodeInfo(CnfNode) ascendant] remove $NodeInfo(CnfNode)
	[$SnapInItem ascendant] remove $SnapInItem
      	#unset snapinitems($SnapInItem)
	unset hscopeitems($SnapInItem)

}

body ApacheICD::DeleteContainer {SnapInItem} {


	foreach son [$SnapInItem contents] {
	DeleteContainer $son
	}

	array set NodeInfo ""
	$SnapInItem GetNodeInfo NodeInfo
	$NameSpace DeleteItem  $hscopeitems($SnapInItem)
	#delete object $hscopeitems($SnapInItem)
      [$NodeInfo(CnfNode) ascendant] remove $NodeInfo(CnfNode)
	[$SnapInItem ascendant] remove $SnapInItem
      	#unset snapinitems($SnapInItem)
	unset hscopeitems($SnapInItem)

}


body ApacheICD::Initialize {ConsoleNameSpace} {

	# Aqui ponemos ya directamente el arbol de configuracion, etc
	# En este caso cnftree
	set NameSpace $ConsoleNameSpace
	ApacheItem $this-root
	array set ScopeItemInfo {ScopePaneIconOpen computer \
	ScopePaneIconClosed computer ScopePaneTitle {Apache Machine} ResultPaneIcon computer ResultPaneTitle {Apache Machine}}
	$this-root SetDisplayInfo ScopeItemInfo

	array set NodeInfo {NodeType MainNode}
	array set NodeInfo "CnfNode [cnftree GetRoot]"
	##################################################################
	# No cnftree, sino hacerlo de otra manera!!!
	###########
	$this-root SetNodeInfo NodeInfo

	set ScopeDataItem(parent) [$NameSpace GetRoot]
	set ScopeDataItem(pIComponentData) $this
	set ScopeDataItem(pSnapInItem) $this-root

	set hscopeitems($this-root) [$NameSpace AddItem ScopeDataItem]

	#$NameSpace GetRoot


}



class ApacheIC {

inherit IComponent

}

class ApacheItem {

inherit SnapInItem

public method SetNodeInfo {NodeInfo}
public method GetNodeInfo {NodeInfo}

}

body ApacheItem::SetNodeInfo { NodeInfo } {

upvar $NodeInfo pNodeInfo

SnapInItem::SetNodeInfo pNodeInfo

set ScopeDataItem(CnfNode) $pNodeInfo(CnfNode) 

}

body ApacheItem::GetNodeInfo { NodeInfo } {

upvar $NodeInfo pNodeInfo

SnapInItem::GetNodeInfo pNodeInfo

set pNodeInfo(CnfNode) $ScopeDataItem(CnfNode)

}
