

class IComponentData {

# El proceso es, segun creo, el siguiente:
# Me llega una llamada, con IParam y quiere saber la informacion de Scope
# Pane de un nodo (SnapItem) en particular. 
# Pedimos el SnapInItem que corresponde a esa cookie
# De ese SnapInItem pillamos el ScopeDataItem y le pedimos la informacion
# que sea (iconos, whatever...)

variable snapin

constructor {} {


}
public method Notify {message cookie}
public method GetDisplayInfo {ScopeItemInfo} 
public method GetNodeInfo {ScopeItemInfo} 
public method Initialize {}

}

body IComponentData::GetNodeInfo {ScopeItemInfo} {

# En ScopeItemInfo vaincluido el Iparam del SnapInItem
# Esta funcion probablemente llamara a GetDisplayInfo apropiada del ScopeItem
# Pero lo necesitamos como intermediario o broker. ScopeItemInfo es solo
# una estructura donde indicamos lo que queremos. Nosotros en principio
# pedimos y devolvemos todo (ScopeIconOpen, closed, resulticon)

upvar $ScopeItemInfo pScopeItemInfo

$pScopeItemInfo(cookie) GetNodeInfo pScopeItemInfo

}

body IComponentData::GetDisplayInfo {ScopeItemInfo} {

# En ScopeItemInfo vaincluido el Iparam del SnapInItem
# Esta funcion probablemente llamara a GetDisplayInfo apropiada del ScopeItem
# Pero lo necesitamos como intermediario o broker. ScopeItemInfo es solo
# una estructura donde indicamos lo que queremos. Nosotros en principio
# pedimos y devolvemos todo (ScopeIconOpen, closed, resulticon)

upvar $ScopeItemInfo pScopeItemInfo

$pScopeItemInfo(cookie) GetDisplayInfo pScopeItemInfo

}


body IComponentData::Initialize {} {

SnapInItem $this-root
array set ScopeItemInfo {ScopePaneIconOpen diropen \
ScopePaneIconClosed dirclosed ScopePaneTitle eComanche ResultPaneIcon dirclosed ResultPaneTitle eComanche}

$this-root SetDisplayInfo ScopeItemInfo

}


class IComponent {

}


class SnapInItem {

inherit Node

public variable ScopeDataItem
public variable ResultDataItem

public method GetNodeInfo { NodeInfo }
public method SetNodeInfo { NodeInfo }
public method GetDisplayInfo { ScopeItemInfo } 
public method SetDisplayInfo { ScopeItemInfo } 
public method GetResultPaneInfo { ResultDataItem } 
public method GetScopePaneInfo { ScopeDataItem } 

# En Scope Data Item van senialados los campos que queremos (seguro?)
# o es que un mismo node puede tener dicersos ScopeDataItem

}

body SnapInItem::SetNodeInfo { NodeInfo } {

upvar $NodeInfo pNodeInfo

set ScopeDataItem(NodeType) $pNodeInfo(NodeType) 

}

body SnapInItem::GetNodeInfo { NodeInfo } {

upvar $NodeInfo pNodeInfo

set pNodeInfo(NodeType) $ScopeDataItem(NodeType)

}



body SnapInItem::GetDisplayInfo { ScopeItemInfo } {

upvar $ScopeItemInfo pScopeItemInfo

set pScopeItemInfo(ScopePaneIconOpen) $ScopeDataItem(IconOpen)
set pScopeItemInfo(ScopePaneIconClosed) $ScopeDataItem(IconClosed)
set pScopeItemInfo(ResultPaneIcon) $ResultDataItem(Icon)
set pScopeItemInfo(ScopePaneTitle) $ResultDataItem(Title)
set pScopeItemInfo(ResultPaneTitle) $ResultDataItem(Title)

return
}

body SnapInItem::SetDisplayInfo { ScopeItemInfo } {

upvar $ScopeItemInfo pScopeItemInfo

set ScopeDataItem(IconOpen) $pScopeItemInfo(ScopePaneIconOpen) 
set ScopeDataItem(IconClosed) $pScopeItemInfo(ScopePaneIconClosed)
set ResultDataItem(Icon) $pScopeItemInfo(ResultPaneIcon) 
set ResultDataItem(Title) $pScopeItemInfo(ResultPaneTitle) 
set ScopeDataItem(Title) $pScopeItemInfo(ScopePaneTitle) 

return
}

